BLOB SCULPTOR ( BS ) version 1.0a
by Alfonso Hermida, Steve Anger, Truman Brown    3/13/94

This program helps you manipulate and model 3D objects thru the use of
blobs.

THIS PROGRAM IS FREEWARE ... BUT, USE AT YOUR OWN RISK.

------------------------------------------------
Requirements:  386 or better with coprocessor  :
	       VGA graphics card               :
	       mouse                           :
------------------------------------------------

You can reach us at:

* TGA BBS (510)524-2780
* Pi Square BBS (301)725-9080     (Alfonso's the Sysop)
* CompuServe: GraphDev forum

Thanks to:

       * Dan Farmer for the interest and enormous amount of feedback and
	 Beta testing.
       
       * Ronald Praver for speeding up suggestions.  Ron is the author
	 of World Render 3D, a wireframe modeler and translator.  He's 
	 currently developing the Windows version of Blob Sculptor.

       * David K. Mason for the program's name.

       * Bill Allen, editor of 3D Artist.  3D Artist is dedicated to 
	 computer graphics and publishes how-to articles on computer
	 graphics programs for different platforms.  For more info:

			     3D Artist
		PO Box 4787, Santa Fe NM 87502-4787
		Voice (505)982-3532   FAX   (505)820-6929


Silicon Graphic's Open GL Developers
------------------------------------

If you know how to program on Open GL for the Silicon Graphics, please
contact Alfonso Hermida.  He has part of the code already ported to GL.
The next step is to create the user interface.


-------------------------------------------------------------------------
DEFINITION :   LMB  = Left Mouse Button
	       RMB  = Right Mouse Button
-------------------------------------------------------------------------

INTERFACE:
----------
BS's display consists of 3 principal views:

				       Vertical Axis    Horizontal Axis
   Top    (upper left window)               Z                 X
   Front  (lower left window)               Y                 X
   Side   (lower right window)              Y                 Z

and a preview window (upper right window referred to as ISO) which can be
modified thru the CAMERA command.  Finally the right side is the MENU 
area.

The horizontal and vertical coordinates of the mouse are displayed in the
MENU area.  The name of the view window where the mouse is currently 
located is displayed above the coordinates.


SUMMARY OF COMMANDS:
--------------------
After each command description the letters F, S, T and Iso are used to 
define in which views the command is valid.  If no letters are present, 
the command doesn't apply in that view.

BS preserves the last command selected.  To execute the previous command,
click the LMB. (Some of the commands can't be repeated - this is done 
either for convenience or for safety).

Most commands may also be activated by pressing the key corresponding to
the highlighted letter of the command as well.


FILE
----
This command presents series of file-related subcommands.
   NEW:   Deletes the whole database - fresh start!
   SAVE:  Writes data to a file.  Files may be saved in the following
	  formats:

	  * BLOB     Blob Sculptor
	  * POV      Persistence of Vision raytracer
	  * POLYRAY  Polyray raytracer
	  * RAYSHADE Rayshade raytracer
	  * RAW      polygons
	  * CTDS     Connect The Dots System
	  * DXF      Autodesk's Data eXchange Format

   LOAD:  Reads in a Blob Sculptor file.  Existing data is overwritten.
   MERGE: Reads in a Blob Sculptor file.  New data is merged with
	  existing data.

   The Blob Sculptor format is an ASCII file described as follows:        
      
      threshold
      x y z strength radius
      x y z strength radius 
      x y z strength radius                                                                 
      x y z strength radius                                                                 
      ....etc....

      * Lines prefixed with a semicolon are ignored as comments *                                                                

   Example: (file HAND.BLB)

      0.6
     -0.413502  0.0253165  0 1 1.50823
      0.43038  -0.00843882 0 1 1.59972
     -0.548523 -1.18987    0 1 1.45752
      0.700422 -1.20675    0 1 1.4348
      1.49367  -0.548523   0 1 0.983246
      1.72996   0.109705   0 1 0.747382
      1.79747   0.683544   0 1 0.683805
      1.82278   1.21519    0 1 0.676372
      0.759494  0.911392   0 1 0.714533
      0.742616  1.50211    0 1 0.676372
      0.691983  2.16034    0 1 0.749914
      0.599156  2.79325    0 1 0.708316
      0.43038   3.50211    0 1 0.718941
     -0.21097   1.08861    0 1 0.679169
     -0.312236  1.74684    0 1 0.714533
     -0.464135  2.42194    0 1 0.629936
     -0.666667  3.09705    0 1 0.698434
     -0.919831  3.80591    0 1 0.715417
     -1.0211    1.0211     0 1 0.640875
     -1.30802   1.64557    0 1 0.621859
     -1.57806   2.23629    0 1 0.670744
     -1.86498   2.84388    0 1 0.620842
     -1.4346   -0.151899   0 1 1.21077
     -1.33333  -1.26582    0 1 1.24168
     -2.04219   0.691983   0 1 0.670743
     -2.4135    1.29958    0 1 0.674501
      1.80591   1.90717    0 1 0.78531
     -2.75105   1.77215    0 1 0.555298

     ;This file creates a 3D hand.

CREATE (F, T, S)
----------------
This command creates a blob component in any of the 3 principal views. 
After selecting this command, click the LMB to define the center of the
component.  Next, move the mouse to define the radius.  Finally, press 
the LMB to accept or the RMB to CANCEL.

To manually create blob components at specific coordinates, you may press
the key combination ALT-C to bring up an input panel for the coordinate
values.  After entering coordinate values, press ENTER (or click on OK) to
accept, or press ESC (or click the RMB) to cancel.

MOVE  (F, T, S)
---------------
You may move a component to another location at anytime by selecting the
MOVE command.  To select the component to be moved, click on any part of 
the circle to be moved.  The circle will be highlighted (yellow color).  
Now, move the mouse to the view where you want to perform the move 
operation and press the LMB.  A ghost image will appear in case you want 
to locate it in it's original place.  Press the LBM to accept the new 
location or RMB to CANCEL.

This command is different from most others because sometimes it's easier
to select a component in a view different from the one where the move will be
performed.


COPY (F, T, S)
--------------
The COPY command behaves the same as the MOVE command but doesn't delete
the original component.


RESIZE (F, T, S)
----------------
You may resize a component at anytime by selecting the RESIZE command.  To
select the component to be resized, click on any part of the circle.  The
circle will be highlighted and a beep will indicate that you may resize
the component.  A ghost image will appear in case you want resize it to
it's original size.  Press LBM to accept the new location or RMB to CANCEL.


REDRAW 
------
This command refreshes ALL the views. Negative components are drawn in red.


ZOOM (F, T, S, Iso)
-------------------
To zoom In or Out, click on any of the views.  The mouse button will
determine the zooming operation:
   LMB     Zoom In
   RMB     Zoom Out

To control the rate of zoom, click on the ZFACTOR button.  This will bring
up a panel where you may input a value for the zoom factor.  Higher values
produce faster zooms.  The maximum zoom factor is 10.


DELETE (F, T, S)
----------------
To delete a component, click the LMB on any part of the circle.  You'll be
asked if you want to continue.  To delete the object click on [OK].


MIRROR, MIRROR AXIS (F, T, S)
-----------------------------
The Mirror command mirrors the selected component, depending on the status of
the Mirror Axis button.  Components are mirrorred about the origin.  If 
a selected component already has a mirror copy, you will be presented with
a message stating such.  Simply click on [OK] and try another component.

PAN (F, T, S)
-------------
You may perform panning by clicking on the PAN command.  By clicking
on any of the 3 principal views, the point will become the center of that
scene.  If the view gets out of limits and you can't return it back, reset
it using the ORIGIN command.

ORIGIN (F, T, S)
----------------
This command puts the origin back in the center of the selected view. Click
on the ORIGIN icon then click on one of the principal views....the 3D axis
will appear in the center.


CAMERA ( Iso )
--------------
Changes the From, At and Up vectors for the Iso view.

PREVIEW (Iso )
--------------
NOTE: Be sure that you have saved your data before previewing it!  This is
      an experimental program.

Generates a wireframe representation of the current scene.  BS tries to
display a hidden line representation, but some triangles may not show up.
This doesn't affect the scene if it is saved as RAW data.  When saved as
RAW data all the triangles will be written.

DENSITY (F, T, S)
-----------------
Select a component to change it's strength(density) value.  The value can
be positive or negative.  To accept the default value press [Enter].
NOTE: Math errors may occur if the density selected is less than or equal
      to the threshold value.  BS has been programmed to reset itself if
      a fatal math error occurs.  In most cases, the reset procedure
      should preserve your data.  If a reset occurs, save your data
      immediately, exit and restart the program.

DETAIL
------
This value, between 20 and 50 determines the resolution in the algorithm 
used to evaluate the blob surfaces.  The values affect the program in 
this way:
	20     fastest,  least resolution, uses less memory
	:
	:
	50     slowest,  best resolution,  uses more memory

For PREVIEWing, it's good to have a small number, between 20 and 30.  For the
final image generation, 30 and up is good (unless you like the resolution
given by lower numbers).

Needless to say, the higher the number, the greater the number of triangles
that will be generated when creating RAW data output.


THRESHOLD
---------
Changes the Threshold value for the blobs.
See NOTE pertaining to Density above.

SNAP
----
Turns On/Off the SNAP feature.

GRID  &  ROW/COL
----------------
The GRID command enables the grid.  The grid is redrawn with every redraw.
The ROW/COL command sets the number of divisions (# of rows = # columns) 
in the grid.

QUIT
----
Exit the program.

ABOUT
-----
Tells you who the authors are!

------------------------------------------------------------------------

ADDITIONAL INFO:

* THRESHOLD          default value 0.6
* STRENGTH (DENSITY) default value 1.0
* Maximum number of components is 500            (INCREASED)
* ROW/COL value      default value 20
-------------------------------------------------------------------------
